//////////////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2014-present, Egret Technology.
//  All rights reserved.
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the Egret nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY EGRET AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
//  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL EGRET AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//////////////////////////////////////////////////////////////////////////////////////


class SceneETC1DragonBonesTest extends DemoScene {

    constructor() {
        super();
    }

    protected onAddToStage(event: egret.Event): void {

        //
        this.dragonBonesFactory1 = new dragonBones.EgretFactory;
        this.dragonBonesFactory2 = new dragonBones.EgretFactory;

        //
        const db1 = this.createDragonBones(this.dragonBonesFactory1, 'winlost', '', '');
        this.addChild(db1);
        db1.animation.gotoAndStopByProgress("1", 0);
        db1.animation.play("1", 0);
        db1.x = this.stage.stageWidth / 2;
        db1.y = this.stage.stageHeight / 2;

        //
        const button = new egret.TextField;
        this.addChild(button);
        button.text = 'SceneETC1DragonBonesTest';
        button.size = 30;
        button.touchEnabled = true;
        button.x = this.stage.stageWidth - button.width;
        button.addEventListener(egret.TouchEvent.TOUCH_TAP, () => {
            //
            db1.dispose();
            //db2.dispose();
            (this.parent as Main).changeToScene(new SceneETC1MovieClipTest);
        }, this);
    }

    protected onRemoveFromStage(event: egret.Event): void {
        this.removeChildren();
        if (this.dragonBonesFactory1) {
            this.dragonBonesFactory1.clear();
            this.dragonBonesFactory1 = null;
        }
        if (this.dragonBonesFactory2) {
            this.dragonBonesFactory2.clear();
            this.dragonBonesFactory2 = null;
        }
    }

    public updateScene(dtMs: number, dtSec: number): void {
    }
}
