//////////////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2014-present, Egret Technology.
//  All rights reserved.
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the Egret nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY EGRET AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
//  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
//  IN NO EVENT SHALL EGRET AND CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
//////////////////////////////////////////////////////////////////////////////////////

class SceneETC1SpriteSheetTest extends DemoScene {

    constructor() {
        super();
    }

    protected onAddToStage(event: egret.Event): void {
        //
        let height = 0;
        let maxWidth = 0;
        //
        const json1: JSON = RES.getRes("house_json");
        const frames1: Object = json1['frames'];
        for (const subkey in frames1) {
            const tex: egret.Texture = RES.getRes("house_sheet#" + subkey);
            const img: egret.Bitmap = new egret.Bitmap(tex);
            this.addChild(img);
            img.x = 0;
            img.y = height;
            height += img.height;
            maxWidth = Math.max(maxWidth, img.width);
        }
        //
        const button = new egret.TextField;
        this.addChild(button);
        button.text = 'SceneETC1SpriteSheetTest';
        button.size = 30;
        button.touchEnabled = true;
        button.x = this.stage.stageWidth - button.width;
        button.addEventListener(egret.TouchEvent.TOUCH_TAP, () => {
            (this.parent as Main).changeToScene(new SceneETC1DragonBonesTest);
        }, this);
    }

    protected onRemoveFromStage(event: egret.Event): void {
        this.removeChildren();
    }
}