# CompressTextureProcessor使用

## 1. 构造函数: constructor (ignoreResource: (imageResourceInfo: RES.ResourceInfo) => boolean) 
![](readme/images/processormap.png)
- ignoreResource由外部传入，忽略对应资源（不加载的压缩纹理资源）
- 返回true即忽略，将用RES.processor.ImageProcessor进行加载
- usePackEtc1Ktx: boolean, 是否启用pack.etc1.ktx文件格式.见6
- 【注意】在RES.loadConfig之前，做RES.processor.map('pack.etc1.ktx', new PackETC1KTXProcessor()); RES.processor.map('image', new CompressTextureProcessor(ignoreResource, true));

## 2. 使用前建议对应2平台iOS，Android资源是齐备的（例如下图）。CompressTextureProcessor会根据平台读取支持的资源
![](readme/images/res.png)
- PC/MAC: egret_icon.png
- iOS如支持pvrtc，则读取egret_icon.pvr.ktx
- Android如支持etc1，则读取egret_icon.ktx + egret_icon_alpha.ktx(alpha遮罩)
- 具体可参考SceneAutoLoadCompressedTexture效果

## 3. CompressTextureProcessor默认对.jpg的文件，不读取对应的alpha遮罩.ktx文件
- 具体可参考SceneAutoLoadCompressedTexture2效果

## 4. 工具来源：
- PowerVRSDK 网址: https://www.imgtec.com/developers/powervr-sdk-tools/
- Mali_Texture_Compression_Tool 网址: https://developer.arm.com/tools-and-software/graphics-and-gaming/graphics-development-tools/mali-texture-compression-tool
- TexturePacker 网址: https://www.codeandweb.com/texturepacker

## 5. 引擎只识别ktx文件，要将对应的pvrtc和etc1打包成ktx格式的文件. 
- ktx描述：https://www.khronos.org/opengles/sdk/tools/KTX/
- ktx文件layout说明: https://www.khronos.org/opengles/sdk/tools/KTX/file_format_spec/
- 参考Babylon.js的命令行工具(Windows)： https://github.com/BabylonJS/Babylon.js/tree/master/Tools/CompressedTextured

## 6. 本样例工程提供了PackETC1KTXColorAndAlphaMaskPlugin的自定义插件，可以将etc1的颜色纹理和alpha遮罩纹理合成一个文件（pack.etc1.ktx），读取需用PackETC1KTXProcessor.
- 优点：节省1次读取alpha遮罩纹理的请求
- PackETC1KTXColorAndAlphaMaskPlugin自定义插件格式为 : 4(head.留用，暂只有0)-4(color buf size, 颜色纹理总大小)-4(alpha buf size, alpha遮罩纹理总大小)-data1(color buf data, 颜色纹理数据)-data2(alpha buf data, alpha遮罩纹理数据)
- 在写入文件的时候，会写入对应.ktx文件同级路径下。例如：将egret_icon.ktx和egret_icon_alpha.ktx合成egret_icon.pack.etc1.ktx
![](readme/images/packktx.png)
- 可以指定自己的格式，并修改对应的plugin和processor即可

            

















